#ifndef DFPLAYER_H
#define DFPLAYER_H

#include <Arduino.h>
#include <SoftwareSerial.h>

enum DFSerialPort {
    SoftwareSerialPort,
    HardwareSerialPort
};

class DFPlayer {
public:
    DFPlayer();
    ~DFPlayer();
    void begin(DFSerialPort portType, int rxPin = 2, int txPin = 3); // 默认软串口引脚 RX=2, TX=3
    void setVolume(uint8_t percent);
    void playTrack(uint16_t track);
    void playCommand(uint8_t cmd);

private:
    void sendCommand(uint8_t cmd, uint16_t param = 0);
    void sendRawCommand(uint8_t *command);
    void setChecksum(uint8_t *command);
    Stream* serial;
    SoftwareSerial* softSerial = nullptr;
};

#endif